Bug 865976 - Review Request: libsigrok - Basic hardware access drivers for logic analyzers
Review Request: libsigrok - Basic hardware access drivers for logic analyzers
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Rex Dieter
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 865979
  Show dependency treegraph
 
Reported: 2012-10-12 21:26 EDT by Alex G.
Modified: 2013-03-22 17:05 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-03-22 17:05:26 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
rdieter: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Alex G. 2012-10-12 21:26:59 EDT
Spec URL: http://g-tech.no-ip.org/~mrnuke/SPECS/libsigrok.spec
SRPM URL: http://g-tech.no-ip.org/~mrnuke/SRPMS/libsigrok-0.1.1-1.fc17.src.rpm
Description: 
libsigrok is a shared library written in C which provides the basic API for
talking to logic analyzer hardware and reading/writing the acquired data into
various input/output file formats.

Koji build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4583315

I will also be needing a sponsor, since this is my first package.
Comment 1 Dan Mashal 2012-10-14 22:51:59 EDT
I cannot sponsor you as a packager but I have done some of the legwork.


[dan@f17 x86_64]$ rpmlint libsigrok-0.1.1-1.fc17.x86_64.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[dan@f17 x86_64]$ rpmlint libsigrok-devel-0.1.1-1.fc17.x86_64.rpm 
libsigrok-devel.x86_64: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
[dan@f17 x86_64]$ rpmlint libsigrok-debuginfo-0.1.1-1.fc17.x86_64.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
rpm[dan@f17 SRPMS]$ rpmlint libsigrok-0.1.1-1.fc17.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[dan@f17 SRPMS]$ 



Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[ ]: Package does not contain kernel modules.
[ ]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[ ]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[ ]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[ ]: Package contains no bundled libraries.
[ ]: Changelog in prescribed format.
[ ]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[ ]: Sources contain only permissible code or content.
[ ]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[ ]: Macros in Summary, %description expandable at SRPM build time.
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[ ]: Package requires other packages for directories it uses.
[ ]: Package uses nothing in %doc for runtime.
[ ]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[ ]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in %package
     devel, %package doc
[ ]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[ ]: Large documentation files are in a -doc subpackage, if required.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "BSD (2 clause)", "GPL (v2 or later)", "GPL (v3 or later)", "Unknown or
     generated". 4 files have unknown license. Detailed output of licensecheck
     in /home/dan/865976-libsigrok/licensecheck.txt
[ ]: License file installed when any subpackage combination is installed.
[ ]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[ ]: Package is named according to the Package Naming Guidelines.
[ ]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Package must own all directories that it creates.
[ ]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[ ]: Package is not relocatable.
[ ]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[ ]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[ ]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[ ]: Useful -debuginfo package or justification otherwise.

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[ ]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[ ]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[ ]: Scriptlets must be sane, if used.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (libsigrok-0.1.1.tar.gz)
[x]: SourceX is a working URL.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libsigrok-0.1.1-1.fc17.src.rpm
          libsigrok-debuginfo-0.1.1-1.fc17.x86_64.rpm
          libsigrok-devel-0.1.1-1.fc17.x86_64.rpm
          libsigrok-doc-0.1.1-1.fc17.noarch.rpm
          libsigrok-0.1.1-1.fc17.x86_64.rpm
libsigrok-devel.x86_64: W: no-documentation
libsigrok-doc.noarch: E: devel-dependency libsigrok-devel
5 packages and 0 specfiles checked; 1 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint libsigrok-debuginfo libsigrok-devel libsigrok-doc libsigro 
k
libsigrok-devel.x86_64: W: no-documentation
libsigrok-doc.noarch: E: devel-dependency libsigrok-devel
libsigrok.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libsigrok.so.0.0.0 /lib64/librt.so.1
libsigrok.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libsigrok.so.0.0.0 /lib64/libz.so.1
libsigrok.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libsigrok.so.0.0.0 /lib64/libusb-0.1.so.4
4 packages and 0 specfiles checked; 1 errors, 4 warnings.
# echo 'rpmlint-done:'



Requires
--------
libsigrok-debuginfo-0.1.1-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    

libsigrok-devel-0.1.1-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /usr/bin/pkg-config  
    libsigrok(x86-64) = 0.1.1-1.fc17
    libsigrok.so.0()(64bit)  
    pkgconfig(glib-2.0)  
    pkgconfig(gthread-2.0)  
    pkgconfig(libftdi)  
    pkgconfig(libusb-1.0)  
    pkgconfig(libzip)  

libsigrok-doc-0.1.1-1.fc17.noarch.rpm (rpmlib, GLIBC filtered):
    
    libsigrok-devel = 0.1.1-1.fc17

libsigrok-0.1.1-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /sbin/ldconfig  
    libc.so.6()(64bit)  
    libftdi.so.1()(64bit)  
    libglib-2.0.so.0()(64bit)  
    libgthread-2.0.so.0()(64bit)  
    libpthread.so.0()(64bit)  
    librt.so.1()(64bit)  
    libusb-0.1.so.4()(64bit)  
    libusb-1.0.so.0()(64bit)  
    libz.so.1()(64bit)  
    libzip.so.2()(64bit)  
    rtld(GNU_HASH)  



Provides
--------
libsigrok-debuginfo-0.1.1-1.fc17.x86_64.rpm:
    
    libsigrok-debuginfo = 0.1.1-1.fc17
    libsigrok-debuginfo(x86-64) = 0.1.1-1.fc17

libsigrok-devel-0.1.1-1.fc17.x86_64.rpm:
    
    libsigrok-devel = 0.1.1-1.fc17
    libsigrok-devel(x86-64) = 0.1.1-1.fc17
    pkgconfig(libsigrok) = 0.1.1

libsigrok-doc-0.1.1-1.fc17.noarch.rpm:
    
    libsigrok-doc = 0.1.1-1.fc17

libsigrok-0.1.1-1.fc17.x86_64.rpm:
    
    libsigrok = 0.1.1-1.fc17
    libsigrok(x86-64) = 0.1.1-1.fc17
    libsigrok.so.0()(64bit)  



MD5-sum check
-------------
http://downloads.sourceforge.net/sigrok/libsigrok-0.1.1.tar.gz :
  CHECKSUM(SHA256) this package     : 4c0e0b27795529fbba38b14226921d3b6a852698fc5207ddff69a47eb26cc63f
  CHECKSUM(SHA256) upstream package : 4c0e0b27795529fbba38b14226921d3b6a852698fc5207ddff69a47eb26cc63f


Generated by fedora-review 0.3.0 (c78e275) last change: 2012-09-24
Buildroot used: fedora-17-x86_64
Command line :/usr/bin/fedora-review -b 865976
Comment 2 Dan Mashal 2012-10-14 22:53:35 EDT
Koji f17 scratch build here:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4589804
Comment 3 Alex G. 2012-10-16 02:49:47 EDT
Regarding: 

Licenses found: "BSD (2 clause)", "GPL (v2 or later)", "GPL (v3 or later)"

I have spoken with upstream, and they are aware some files are GPLv2+. However, the library as a whole is GPLV3+, and the headers installed by the -devel package are all GPLv3+. As a whole, the package is GPLv3+, and I think it doesn't make sense to specify both "GPLv3+ and GPLV2+". The same argument applies for the BSD files.
I don't have a problem specifying all the licenses, although what is shipped ends up being GPLv3+. What is your take?
Comment 4 Dan Mashal 2012-11-13 05:41:25 EST
GPLv2+ and BSD should be good enough
Comment 5 Alex G. 2012-11-16 12:37:29 EST
"GPLv2+ and BSD" completely misses the GPLv3+, which is the resulting license of the package. I can't help but imagine this might cause some confusion.
From the licensing guidelines, I am led to believe that
"GPLv3+ and GPLv2+ and BSD"
is the correct way of specifying the license. A bit confusing, I must admit.
Comment 6 Rex Dieter 2012-11-16 12:45:53 EST
Depends on how each license is used in the combined work.  It's the packager's perrogative whether to list a simple aggregated license or to list them all (I personally prefer the former).  In short, either
# combined GPLv3+ and GPLv2+ and BSD
License: GPLv3+
or
License: GPLv3+ and GPLv2+ and BSD
is acceptable

also, i'd be willing to serve as sponsor if dan (or anyone else) is willing to do the rest of the review
Comment 7 Alex G. 2012-12-01 11:00:19 EST
I think the best solution is:
# combined GPLv3+ and GPLv2+ and BSD
License: GPLv3+
This is also upstream's intention. They won't update the "offending" license headers for a few reasons:
BSD files: The authors prefer that their work remains under BSD.
GPLv2+ files: Not enough interest in updating the headers, as it's 100% compatible with GPLv3+.

SPEC: http://g-tech.no-ip.org/~mrnuke/fedrev/libsigrok-0.1.1-2/libsigrok.spec
SRPM: http://g-tech.no-ip.org/~mrnuke/fedrev/libsigrok-0.1.1-2/libsigrok-0.1.1-2.fc17.src.rpm
Comment 8 Rex Dieter 2012-12-11 09:48:30 EST
I can review today.

Alex, can you mention what your FAS username is (i'll need that to sponsor you)?
https://fedoraproject.org/wiki/Join_the_package_collection_maintainers#Create_a_Fedora_Account
Comment 9 Alex G. 2012-12-11 10:28:06 EST
FAS username: mrnuke
Comment 10 Alex G. 2013-01-16 12:05:51 EST
ping?
Comment 11 Rex Dieter 2013-01-16 14:26:51 EST
Sorry for the delay, will try to wrap this up over this week.
Comment 12 Rex Dieter 2013-03-12 15:13:24 EDT
boy I suck, sorry I forgot about this.  Here we go...

1.  -doc SHOULD drop
Requires:       %{name} = %{version}-%{release}

It's just documentation, really has no strict dependency on the base package.  If you *do* really want a dep, since this is api docs, I'd recommend depending on %{name}-devel instead


naming: ok

macros: ok


2.  SHOULD track library soname, I'd recommend using a few less * globs, and track files closer, using (something like) this instead:

%files
....
%{_libdir}/libsigrok.so.0*

%files devel
...
%{_includedir}/sigrok*.h
%{_libdir}/libsigrok.so
%{_libdir}/pkgconfig/libsigrok.pc

because if any of these change, it means the pkg api/abi has changed too, and excessive globbing will hide that fact, and could lead to surprises later (broken dependencies in packages depending on this one).


sources: ok
285c0b69aa3d36a431bf752c4f70c755  libsigrok-0.1.1.tar.gz

licensing: ok


A lot of the other details were verified already by Dan.  As there are no blockers here I can see,   APPROVED and SPONSORED.

please do consider addressing the SHOULD items I mentioned prior to doing any official builds.
Comment 13 Alex G. 2013-03-13 14:36:36 EDT
New Package SCM Request
=======================
Package Name: libsigrok
Short Description: Basic hardware access drivers for logic analyzers
Owners: mrnuke
Branches: f18 f19
InitialCC: mrnuke
Comment 14 Gwyn Ciesla 2013-03-13 15:20:59 EDT
Git done (by process-git-requests).
Comment 15 Fedora Update System 2013-03-14 10:14:39 EDT
libsigrok-0.1.1-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/libsigrok-0.1.1-3.fc18
Comment 16 Fedora Update System 2013-03-14 20:04:59 EDT
libsigrok-0.1.1-3.fc18 has been pushed to the Fedora 18 testing repository.
Comment 17 Fedora Update System 2013-03-22 17:05:29 EDT
libsigrok-0.1.1-3.fc18 has been pushed to the Fedora 18 stable repository.

Note You need to log in before you can comment on or make changes to this bug.